db $42
JMP bottom : JMP top : JMP sides
JMP sprite_vertical : JMP sprite_horizontal
JMP cape : JMP fireball
JMP top_corner : JMP body_inside : JMP head_inside

print "decreases the ball's speed"

!decrement = $0A
; !limit = $00

!sound_n = $0E
!sound_c = $1DF9

debuff_y_speed:
		LDA $AA,x
		BMI .negative
		SEC
		SBC #!decrement
		BPL +
		LDA #$00
	+
		STA $AA,x
		RTS
		
	.negative
		CLC
		ADC #!decrement
		BMI +
		LDA #$00
	+
		STA $AA,x
		RTS
		
debuff_x_speed:
		LDA $B6,x
		BMI .negative
		SEC
		SBC #!decrement
		BPL +
		LDA #$00
	+
		STA $B6,x
		RTS
		
	.negative
		CLC
		ADC #!decrement
		BMI +
		LDA #$00
	+
		STA $B6,x
		RTS
		
sprite_vertical:
sprite_horizontal:
		LDA $7FAB10,x
		AND #$08
		BEQ return
		LDA $7FAB9E,x
		CMP #$01
		BNE return
		
		LDA #!sound_n
		STA !sound_c
		
		JSR debuff_x_speed
		JSR debuff_y_speed

bottom:
top:
sides:
top_corner:
body_inside:
head_inside:
cape:
fireball:

return:
		RTL
