db $42
JMP bottom : JMP top : JMP sides
JMP sprite_vertical : JMP sprite_horizontal
JMP cape : JMP fireball
JMP top_corner : JMP body_inside : JMP head_inside

!increment = $28
!limit = $48

!sound_n = $08
!sound_c = $1DFC

sprite_vertical:
		LDA $7FAB10,x
		AND #$08
		BEQ return
		LDA $7FAB9E,x
		CMP #$01
		BNE return
		
		LDA #!sound_n
		STA !sound_c
		
		LDA $1588,x
		ORA #$0C
		STA $1588,x
		
		LDA $AA,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $AA,x
		RTL
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $AA,x
		RTL
		

sprite_horizontal:
		LDA #!sound_n
		STA !sound_c
		
		LDA $1588,x
		ORA #$03
		STA $1588,x
		

		LDA $7FAB10,x
		AND #$08
		BEQ return
		LDA $7FAB9E,x
		CMP #$01
		BNE return
		
		LDA $B6,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $B6,x
		RTL
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $B6,x
		RTL

bottom:
top:
sides:
top_corner:
body_inside:
head_inside:
cape:
fireball:

return:
		RTL
