incsrc "sublib_defines.asm"

; misc settings
!ball_sprn = $01

; !spr_ext_1 is coins to give
; !spr_ext_2 is the tile

;----------------------------------------

print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR main
		PLB
print "INIT ",pc
		RTL
		
;----------------------------------------
	
main:
		JSR draw_gfx
		LDA !spr_status,x
		EOR #$08
		ORA $9D
		BNE .return
		
		JSL $83B69F			; get clipping A
		LDX #$0B
	.loop
		CPX $15E9
		BEQ .next
		LDA !spr_status,x
		CMP #$08
		BCC .next
		LDA !spr_number_c,x
		CMP #!ball_sprn
		BNE .next
		JSL $83B6E5			; get clipping B
		JSL $83B72B
		BCS .found
	.next:
		DEX
		BPL .loop
		LDX $15E9
	.return:
		RTS
		
	.found:
		LDX $15E9
		STZ !spr_status,x
		
		LDA #$1C
		STA $1DF9
		
		LDA $13CC
		CLC
		ADC !spr_ext_1,x
		STA $13CC
		
		RTS
		
;----------------------------------------

draw_gfx:
		JSL !get_draw_info
		
		LDA $00
		STA $0300,y
		LDA $01
		STA $0301,y
		LDA !spr_ext_2,x
		STA $0302,y
		LDA !spr_tile_props,x
		ORA $64
		STA $0303,y
		
		; one 16x16 tile
		LDY #$02
		LDA #$00
		JSL $81B7B3
		RTS
		