nmi_code:
	LDA $010B
	BNE +
	LDA $0100
	CMP #$14
	BEQ ++
	CMP #$0B
	BEQ ++
	BRA +
++
	STZ $0464
	STZ $0465
	STZ $0468
	STZ $0411
	STZ $0412
	STZ $2121
	LDA $0703 : STA $2122
	LDA $0704 : STA $2122
	LDA $0D9D : STA $212C
	LDA $0D9E : STA $212D
	LDA #$40 : STA $2133
	JSR BlockAnimation
	JMP BlockVRAMUpload
+
	LDA #$03
	STA $2101
	STZ $2133
	RTS


!BlockUpdate = $0F80
!BlockVRAMAddr = $0F81
!BlockIndex = $0F83

BlockVRAMUpload:
	PHB : PHK : PLB
	LDX !BlockUpdate
	BEQ +
-
	STZ $2115
	REP #$20
	LDA !BlockVRAMAddr,x
	STA $2116
	LDY !BlockIndex,x
	LDA .tiletable,y
	SEP #$20
	STA $2118
	XBA
	STA $2118
	REP #$21
	LDA !BlockVRAMAddr,x
	ADC #$0080
	STA $2116
	LDA .tiletable+2,y
	SEP #$20
	STA $2118
	XBA
	STA $2118
	DEX #3 : BNE -
	STZ !BlockUpdate
+
	PLB : RTS

.tiletable
	db $00,$00,$00,$00	;blank
	db $5C,$5D,$5E,$5F	;coin collect 1
	db $35,$36,$37,$38	;? yellow
	db $39,$3A,$3B,$3C	;? red
	db $3D,$3E,$3F,$40	;? green
	db $60,$61,$62,$63	;coin collect 2
	db $0D,$0E,$0F,$10	;cement
	db $11,$12,$13,$14	;off
	db $15,$16,$17,$18	;on
	db $01,$02,$03,$04	;solid blue
	db $19,$1A,$1B,$1C	;solid yellow
	db $1D,$1E,$1F,$20	;solid red
	db $21,$22,$23,$24	;solid green

BlockAnimation:
	PHB : PHK : PLB
	LDA $14
	AND #$03
	ASL : TAX
	JMP (+,x) : +
	dw .anim0
	dw .anim1
	dw .anim2
	dw .anim3
.anim0
	LDY #$FE : STY $0C
	LDX #$02
	BRA +
.anim1
	LDY #$02 : STY $0C
	LDX #$06
	BRA +
.anim2
	LDY #$06 : STY $0C
	LDX #$0A
	BRA +
.anim3
	LDY #$0A : STY $0C
	LDX #$0C

+
	LDA $14
	LSR #3
	AND #$03
	ASL : TAY
	LDA #$80
	STA $2115
	LDA #$7E : STA $4314
	STZ $4310
	LDA #$19 : STA $4311
-
	REP #$20
	LDA .ADDRVRAM,x
	STA $2116
	LDA .ADDRpoint,x
	STA $0A
	LDA ($0A),y
	STA $4312
	SEP #$20
	LDA #$01 : STA $4316
	INC : STA $420B
	DEX #2 : CPX $0C : BNE -
	PLB : RTS

.ADDRpoint
dw .noteblockADDR
dw .coinADDR
dw .muncherADDR
dw .questionblueADDR
dw .questionyellowADDR
dw .questionredADDR
dw .questiongreenADDR

.ADDRVRAM
dw $0940,$0140,$0240
dw $0C40,$0D40,$0E40,$0F40

.noteblockADDR
dw $B600,$B700,$B600,$B800
.coinADDR
dw $B900,$BA00,$BB00,$BC00
.muncherADDR
dw $BD00,$BE00,$BD00,$BE00
.questionblueADDR
dw $C100,$C200,$C300,$C400
.questionyellowADDR
dw $C500,$C600,$C700,$C800
.questionredADDR
dw $C900,$CA00,$CB00,$CC00
.questiongreenADDR
dw $CD00,$CE00,$CF00,$D000