db $42
JMP bottom : JMP top : JMP sides
JMP sprite_vertical : JMP sprite_horizontal
JMP cape : JMP fireball
JMP top_corner : JMP body_inside : JMP head_inside

print "boosts the ball's speed"

!increment = $12
!limit = $38

!sound_n = $08
!sound_c = $1DFC

boost_y_speed:
		LDA $AA,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $AA,x
		RTS
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $AA,x
		RTS
		
boost_x_speed:
		LDA $B6,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $B6,x
		RTS
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $B6,x
		RTS
		
sprite_vertical:
sprite_horizontal:
		LDA $7FAB10,x
		AND #$08
		BEQ return
		LDA $7FAB9E,x
		CMP #$01
		BNE return
		
		LDA #!sound_n
		STA !sound_c
		
		JSR boost_x_speed
		JSR boost_y_speed

bottom:
top:
sides:
top_corner:
body_inside:
head_inside:
cape:
fireball:

return:
		RTL
