db $42
JMP bottom : JMP top : JMP sides
JMP sprite_vertical : JMP sprite_horizontal
JMP cape : JMP fireball
JMP top_corner : JMP body_inside : JMP head_inside

print "shatters on contact with the ball"

!increment = $12
!limit = $38

!sound_n = $08
!sound_c = $1DFC

boost_y_speed:
		LDA $AA,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $AA,x
		RTS
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $AA,x
		RTS
		
boost_x_speed:
		LDA $B6,x
		BMI .negative
		CLC
		ADC #!increment
		CMP #!limit
		BCC +
		LDA #!limit
	+
		STA $B6,x
		RTS
		
	.negative
		SEC
		SBC #!increment
		CMP #-!limit
		BCS +
		LDA #-!limit
	+
		STA $B6,x
		RTS

sprite_vertical:
		LDA #$01
		STA $00
		BRA interact

sprite_horizontal:
		STZ $00

interact:
		LDA $7FAB10,x
		AND #$08
		BEQ return
		LDA $7FAB9E,x
		CMP #$01
		BNE return
		
		; lmao why
		LDA $00
		BEQ .skip_vert
		LDA $1588,x
		AND #~$03
		ORA #$0C
		STA $1588,x
		
		JSR boost_x_speed
		JSR boost_y_speed
		
	.skip_vert
		
		%sprite_block_position()
		%rainbow_shatter_block()
		
bottom:
top:
sides:
top_corner:
body_inside:
head_inside:
cape:
fireball:

return:
		RTL
