!plyrOAM	= $0308	; > OAM slot for player sprite
!plyrSZE	= ((!plyrOAM-$200)>>2)+$420	; > Corresponding address
!plyrTILE	= $C2	; > Sprite tile the player uses
!plyrPROP	= $20	; > Properties of that tile

!plyrY		= $0F60	; > Player Y position							; \ Note: These need to be in that order in ram otherwise the update XY routine won't work properly
!plyrDIST	= $0F61	; > How far the player is away from the middle	; |
!plyrX		= $0F62	; > Player X position							; /
!plyrYSpeed	= $0F63	; > Player Y speed																	; \ Note: These too need to be in this order in ram for the same reason
!plyrXSpeed	= $0F64	; > Player X speed																	; |
!plyrXTmp	= $0F65	; > X speed value used to index !plyrX directly rather than using !plyrDIST			; /
!plyrSTATE	= $0F66	; > Player state (00 - On platform, 01 - Falling off of platform, 02 - Inactive)

print "-------- Player info --------"
print "- OAM slot ---- $", hex(!plyrOAM)
print "- SIZE -------- $", hex(!plyrSZE)
print "- Tile -------- $", hex(!plyrTILE)
print "- Properties--- $", hex(!plyrPROP)