!minSpeed	= $20	; > Minimal Y speed
!maxSpeed	= $40	; > Maximal Y speed

!sprAmount	= $20	; > How many sprites can be processed at a time. More than $80 will overwrite stuff outside of OAM
!baseAddr	= $7FA000	; > Base address for sprite information (and HDMA tables defined in mode7.asm)

!state	= !baseAddr					; \ Sprite Info
!X	= !baseAddr+!sprAmount			; |
!Y	= !baseAddr+(!sprAmount*2)		; |
!XSpeed	= !baseAddr+(!sprAmount*3)	; |
!YSpeed	= !baseAddr+(!sprAmount*4)	; |
!sprTPE	= !baseAddr+(!sprAmount*5)	; / Sprite type. Used to index tables that determine what to give the player
!Xfrac	= !baseAddr+(!sprAmount*6)
!Yfrac	= !baseAddr+(!sprAmount*7)

; Print out sprite information
print "-------- Sprite info --------"
print "- State ------- $", hex(!state)
print "- X Position -- $", hex(!X)
print "- Y Position -- $", hex(!Y)
print "- X Speed ----- $", hex(!XSpeed)
print "- Y Speed ----- $", hex(!YSpeed)
print "- Sprite type - $", hex(!sprTPE)
print "- X frac ------ $", hex(!Xfrac)
print "- Y frac ------ $", hex(!Yfrac)
print "------ End        info ------"