;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This block will explode when hit by the ship, and clears its speed.
;;  If hit on the side, just stops it from pushing into it.
;;
;; (for the record, I couldn't just use GPS's shatter routine
;;  since vertical levels don't work with it)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!rocketSpr	=	$00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

db $42
	JMP Return : JMP Return : JMP Return : JMP Hit : JMP Side
	JMP Return : JMP Return : JMP Return : JMP Return : JMP Return


;; Shatter and clear the ship's X speed.
Hit:
	LDA $7FAB9E,x
	CMP #!rocketSpr
	BNE Return
	LDA #$F0
	STA $AA,x
	
	%sprite_block_position()
	
	PHB
	LDA #$02
	PHA
	PLB
	LDA #$00
	JSL $028663 	; shatter
	PLB
	
	LDA #$02
	STA $9C
	JSL $00BEB0		; erase block
	RTL



;; Push out of the block if hitting the side.
Side:
	LDA $B6,x
	BMI .leftWall
	DEC $E4,x
	BRA .clearSpeed
  .leftWall
	INC $E4,x
  .clearSpeed
	STZ $B6,x
Return:
	RTL

print "This block will explode when hit by the ship."