;==========================================
;; Dr Kawashima's Devilish Brain Training
;; - Devilish Mice
;=====Description============================
;; This is a part of game of Devilish Training.
;; It has influence good for a brain function.
;; This game aims to train your working memory.
;; But when u play this too long time, may damage your brain...
;; Do not play this game too much time please.
;==========================================
	org $01DDAC
autoclean	JSL Init
	RTS
	org $01DE2A
autoclean	JSL Main
	RTS
;==========================================
	!Xpos		= $1A00
	!Ypos		= $1A30
	!Tile		= $1A60
	!Mask		= $1A90

	!Xpos2		= $1AC0
	!Ypos2		= $1AC4
	!Tile2		= $1AC8
	!Ram1		= $1ACC
	!Ram2		= $1AD0
	!Ram3		= $1AD4
	!Ram4		= $1AD8
	!Ram5		= $1ADC

	!Ram6		= $1AE0
	!Ram7		= $1AE1
	!Ram8		= $1AE2
	!Ram9		= $1AE3
	!RamA		= $1AE4
	!RamB		= $1AE5
	!RamC		= $1AE6
	!Counter		= $1AE7
;==========================================
;; Init and Main JSL
;==========================================
freecode
Init:	LDY #$0B
-	CPY $15E9
	BEQ +
	LDA $009E,y
	CMP $9E,x
	BNE +
	STZ $14C8,x
	RTL
+	DEY
	BPL -
;	LDA $94 : STA $1504,x
Reset:	LDA $148B
	EOR $13
	STA $148B
	JSL $81ACF9
	REP #$20
	LDY #$3E
	LDA.w #$0000
-	STA !Xpos,y
	STA !Xpos+$40,y
	STA !Xpos+$80,y
	STA !Xpos+$C0,y
	STA !Xpos+$100,y
	DEY #2
	BPL -
	SEP #$20
	LDA #$10
	STA $1528,x
	STZ $1594,x
	STZ $C2,x
	LDA #$78
	STA $E4,x
	LDA #$30
	STA $D8,x
	RTL
Main:	PHB
	PHK
	PLB
	JSR MainCode
	PLB
	RTL
;==========================================
;; Main Code
;==========================================
MainCode:
	PEA.w SubGfx-$01
;	LDA $1504,x : STA $94 : STZ $7B
	LDA $C2,x
	ASL A
	TAY
	REP #$20
	LDA .Ptr,y
	PHA
	SEP #$20
	LDA $9D
	BNE .Return
;	LDA $16 : AND #$20 : BEQ + : JSL Reset : +
	REP #$20
	LDY #$1A
-	LDA $0308,y
	STA $0228,y
	DEY #2
	BPL -
	LDY #$08
-	LDA $0462,y
	STA $042A,y
	DEY #2
	BPL -
	LDY #$06
-	LDA $03D0,y
	STA $0244,y
	DEY #2
	BPL -
	LDA $0494
	STA $0431
	SEP #$20
	LDA $C2,x
	CMP #$05
	BNE .Return
	LDA $15
	AND #$40
	LSR #4
	STA $00
	LDA $15
	AND #$03
	ORA $00
	TAY
	LDA .Spd,y
	STA $B6,x
	LDA $15
	LSR #2
	AND #$03
	ORA $00
	TAY
	LDA .Spd,y
	STA $AA,x
	JSL $81801A
	JSL $818022
.Return	RTS
.Ptr	dw Level-$01,MouseSet-$01,Count-$01,Gen-$01,Move-$01,Check-$01,Fin-$01,End-$01
.Spd	db $00,$18,$E8,$00,$00,$30,$D0,$00
;==========================================
Level:	LDA #$BF
	STA $1464
-	JSL $81ACF9
	EOR $148E
	AND #$1F
	CMP #$1E
	BCS -
	STA $151C,x
	LDA $16
	ORA $18
	BPL .Return
	INC $C2,x
.Return	RTS
;==========================================
MouseSet:	LDA $151C,x
	AND #$1E
	TAX
	LSR A
	INC A
	STA $00
	REP #$20
	LDA .0,x
	STA $01
	LDA .XPtr,x
	STA $03
	LDA .YPtr,x
	STA $05
	SEP #$20
	LDX #$00
.Loop	LDY $02
	LDA ($05),y
	STA $07
	LDY $01
-	LDA ($03),y
	STA !Xpos,x
	LDA $07
	STA !Ypos,x
	INX
	DEY
	BPL -
	DEC $02
	BPL .Loop
	JSL $81ACF9
-	REP #$20
	LDA $148D
	STA $4204
	SEP #$20
	STX $4206
	JSL $81ACF9
	LDY $4216
	LDA !Tile,y
	BNE -
	LDA #$02
	STA !Tile,y
	DEC $00
	BPL -
	LDX $15E9
	INC $C2,x
	LDA #$FF
	STA $1540,x
	LDA #$23
	STA $1DFC
	RTS
.X4	db $60,$70,$80,$90
.X5	db $58,$68,$78,$88,$98
.X6	db $50,$60,$70,$80,$90,$A0
.XPtr	dw .X4,.X4,.X4,.X4,.X4,.X4,.X4,.X5,.X5,.X5,.X5,.X6,.X6,.X6,.X6,.X6
.0	dw $0203,$0203,$0203,$0203,$0203,$0303,$0303,$0304
	dw $0304,$0404,$0404,$0405,$0405,$0405,$0505,$0505
.Y3	db $5F,$6F,$7F
.Y4	db $57,$67,$77,$87
.Y5	db $4F,$5F,$6F,$7F,$8F
.Y6	db $47,$57,$67,$77,$87,$97
.YPtr	dw .Y3,.Y3,.Y3,.Y3,.Y3,.Y4,.Y4,.Y4,.Y4,.Y5,.Y5,.Y5,.Y5,.Y5,.Y6,.Y6
;==========================================
Count:	LDA $151C,x
	LSR #2
	STA $06
	LDA $1540,x
	BNE +
	INC $C2,x
.Return	RTS
.SE	db $00,$22,$23,$23
+	ROL #2
	BIT #$FC
	BNE +
	ROL A
	AND #$03
	TAY
	LDX .SE,y
	STX $1DFC
	BRA ++
+	ROL A
	AND #$03
++	TAY
	BNE ++
	LDX #$08
-	LDA #$F0
	CMP $0201,x
	BEQ +
	INX #4
	CPX #$F8
	BNE -
+	LDA #$70
	STA $0200,x
	LDA #$70
	STA $0201,x
	LDA #$C0
	STA $0202,x
	LDY $06
	LDA SubGfx_Color,y
	STA $0203,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0420,y
	LDY #$00
++	LDX #$08
-	LDA #$F0
	CMP $0201,x
	BEQ +
	INX #4
	CPX #$FC
	BNE -
+	LDA .XDisp,y
	STA $0200,x
	LDA #$70
	STA $0201,x
	LDA .Tile,y
	STA $0202,x
	LDY $06
	LDA SubGfx_Color,y
	STA $0203,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0420,y
	LDX $15E9
	RTS
.Tile	db $C2,$EC,$EA,$E8
.XDisp	db $80,$7C,$7C,$7C
;==========================================
Gen:	LDA $151C,x
	AND #$1E
	TAY
	REP #$20
	LDA .XPtr,y
	STA $00
	LDA .YPtr,y
	STA $02
	SEP #$20
	TYA
	LSR A
	STA $09
	LDA $1528,x
	STA $07
	LDA !Ram6
	STA $0F
--	JSL $81ACF9
	AND #$01
	STA $0A
	LDX !Ram8
	STX $08
-	LDY $09
	JSL $81ACF9
	AND #$0F
	CMP .Set,y
	BCS -
	LDY $0A
	BEQ +
	LDY $09
	CMP .Set2,y
	BCS ++
	BRA -
	LDY $09
+	CMP .Set2,y
	BCS -
++	STA !Ram1,x
	STZ !Ram2,x
	TAY
	LDA $148E
	AND #$01
	STA $04
	ASL A
	STA $05
	LDA ($00),y
	STA !Xpos2,x
	ORA $04
	BNE +
	LDA #$F0
	STA !Xpos2,x
+	LDA ($02),y
	BNE +
	INC $05
+	STA !Ypos2,x
	ORA $04
	BNE +
	LDA #$DE
	STA !Ypos2,x
+	LDA !Ram6
	BEQ +
	BMI +
	LDA $07
	BPL ++
	LDA #$01
	BRA +++
++	JSL $81ACF9
	AND #$01
	BEQ +
+++	DEC !Ram6
+	STA $06
	LDA $05
	ASL A
	ORA $06
	STA !Tile2,x
	LDY $09
	DEX
	BMI +
	JMP -
+	LDA !Ram8
	BEQ ++
	STZ !Counter
	LDY !Ram8
---	TYX
	DEX
-	LDA !Ram1,y
	CMP !Ram1,x
	BNE +
	STX $0D
	STY $0E
	INC !Counter
	LDA !Counter
	CMP #$02
	BCC +
	LDA $0F
	STA !Ram6
	JMP --
+	DEX
	BPL -
	DEY
	BNE ---
	LDA !Counter
	DEC A
	BNE ++
	LDY $0E
	LDA !Tile2,y
	AND #$06
	STA $0F
	TAX
	LDA Move_x,x
	STA $0B
	LDA Move_y,x
	STA $0C
	LDX $0D
	LDA !Tile2,x
	AND #$03
	ORA $0F
	STA !Tile2,x
	LDA $0B
	CLC
	ADC !Xpos2,y
	STA !Xpos2,x
	LDA $0C
	CLC
	ADC !Ypos2,y
	STA !Ypos2,x
++	LDX $15E9
	INC $C2,x
	RTS
.Set	db $07,$07,$07,$07,$07,$08,$08,$09,$09,$0A,$0A,$0B,$0B,$0B,$0C,$0C
.Set2	db $04,$04,$04,$04,$04,$04,$04,$05,$05,$05,$05,$06,$06,$06,$06,$06
.X7	db $60,$70,$80,$90,$00,$00,$00
.X8	db $60,$70,$80,$90,$00,$00,$00,$00
.X9	db $58,$68,$78,$88,$98,$00,$00,$00,$00
.XA	db $58,$68,$78,$88,$98,$00,$00,$00,$00,$00
.XB	db $50,$60,$70,$80,$90,$A0,$00,$00,$00,$00,$00
.XC	db $50,$60,$70,$80,$90,$A0,$00,$00,$00,$00,$00,$00
.XPtr	dw .X7,.X7,.X7,.X7,.X7,.X8,.X8,.X9,.X9,.XA,.XA,.XB,.XB,.XB,.XC,.XC
.Y7	db $00,$00,$00,$00,$5F,$6F,$7F
.Y8	db $00,$00,$00,$00,$57,$67,$77,$87
.Y9	db $00,$00,$00,$00,$00,$57,$67,$77,$87
.YA	db $00,$00,$00,$00,$00,$4F,$5F,$6F,$7F,$8F
.YB	db $00,$00,$00,$00,$00,$00,$4F,$5F,$6F,$7F,$8F
.YC	db $00,$00,$00,$00,$00,$00,$47,$57,$67,$77,$87,$97
.YPtr	dw .Y7,.Y7,.Y7,.Y7,.Y7,.Y8,.Y8,.Y9,.Y9,.YA,.YA,.YB,.YB,.YB,.YC,.YC
.Tile	db $E2,$24
;==========================================
Move:	LDY !Ram8
	STY !Counter
-	LDY !Counter
	JSR .M	
	DEC !Counter
	BPL -
	LDY !Ram8
-	LDA !Ram2,y
	DEC A
	ORA !Ram3,y
	ORA !Ram4,y
	BNE +
	DEC A
	STA !Ram1,y
	INC !Counter
+	DEY
	BPL -
	LDA !Counter
	CMP !Ram8
	BNE .Return
	LDA $1528,x
	BMI +
	LDA $1528,x
	AND #$0F
	TAY
	LDA .Num,y
	TAY
-	JSL $81ACF9
	AND .Num2,y
	CMP .Num3,y
	BCS -
	STA !Ram8
	DEC $C2,x
.Return	RTS
+	LDY #$01
	LDA !Ram6
	BNE -
	INC $C2,x
	RTS
.M	LDA !Ram2,y
	DEC A
	ORA !Ram3,y
	ORA !Ram4,y
	BNE +
	RTS
+	LDA !Ram4,y
	BEQ +
	LDA $151C,x
	AND #$01
	EOR #$FF
	CLC
	ADC !Ram4,y
	STA !Ram4,y
	BNE +
	DEC $1528,x
	RTS
+	LDA !Tile2,y
	AND #$06
	STA $00
	LDA $151C,x
	LSR A
	AND #$0F
	TAY
	LDA .XPos2,y
	STA !Ram9
	LDA .XPos,y
	STA !RamA
	LDA .YPos2,y
	STA !RamB
	LDA .YPos,y
	STA !RamC
	STY $0E
	LDA $151C,x
	AND #$01
	ORA $00
	TAY
	STY $0D
	LDX !Counter
	LDA #$01
	STA $0F
	LDA !Xpos2,x
	STA $0B
	CMP !Ram9
	BCS +
	CMP !RamA
	BCS ++
+	STZ $0F
++	CLC
	ADC .XSpd,y
	STA !Xpos2,x
	LDA !Ypos2,x
	STA $0C
	CMP !RamB
	BCS +
	CMP !RamC
	BCS ++
+	STZ $0F
++	CLC
	ADC .YSpd,y
	STA !Ypos2,x
	LDA $0F
	BEQ +
	JSR Swap
+	LDA !Ram3,x
	BNE +
	TXY
	JMP .Skip
+	LDA $0D
	AND #$01
	TAY
	LDA .YSpd,y
	ORA .XSpd,y
	CLC
	ADC !Ram3,x
	STA !Ram3,x
.A	LDA $0D
	AND #$FE
	TAY
	REP #$20
	LDA .Ptr,y
	STA $09
	LDA .TilePtr,y
	STA $00
	LDA .TilePtr2,y
	PHA
	SEP #$20
	LDA .x,y
	STA $04
	LDA .y,y
	STA $05
	LDY $0E
	LDA ($09),y
	STA $02
	STA $03
	LDA !Ram3,x
	STX $08
	STA $0A
	LDA $0B
	STA $06
	LDA $0C
	STA $07
	LDX #$50
-	LDA #$F0
	CMP $0201,x
	BNE .Next
	LDA $03
	BEQ +
	LDY #$00
	CMP $02
	BEQ ++
	LDA #$E2
	LDY #$20
	BRA +++
+	LDY #$FF
++	PHY
	LDY $0A
	PLA
	BEQ +
	LDA ($00),y
	BRA ++
+	LDA ($01,s),y
	PLY
	PLY
++	LDY #$21
+++	STA $0202,x
	TYA
	STA $0203,x
	LDA $06
	STA $0200,x
	CLC
	ADC $04
	STA $06
	LDA $07
	STA $0201,x
	CLC
	ADC $05
	STA $07
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0420,y
	DEC $03
.Next	INX #4
	LDA $03
	BPL -
	LDY $08
.Skip	STY $01
	LDX #$58
	LDA $14
	AND #$08
	LSR #3
	STA $00
-	LDA #$F0
	CMP $0301,x
	BEQ +
	INX #4
	CPX #$FC
	BNE -
+	LDA !Xpos2,y
	STA $0300,x
	LDA !Ypos2,y
	STA $0301,x
	LDA !Tile2,y
	AND #$01
	ASL A
	ORA $00
	TAY
	LDA .Tile,y
	STA $0302,x
	LDA .Color,y
	STA $0303,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0460,y
	INX #4
	DEC $0F
	BPL +
	LDX $15E9
	RTS
+ : -	LDA #$F0
	CMP $0301,x
	BEQ +
	INX #4
	CPX #$FC
	BNE -
+	LDA $0D
	AND #$FE
	TAY
	REP #$20
	LDA .Ptr,y
	STA $08
	STZ $04
	SEP #$20
	PHY
	LDY $0E
	LDA ($08),y
	STA $02
	PLY
-	LDA .x,y
	CLC
	ADC $04
	STA $04
	LDA .y,y
	CLC
	ADC $05
	STA $05
	DEC $02
	BNE -
	LDY $01
	LDA !Xpos2,y
	CLC
	ADC $04
	STA $0300,x
	LDA !Ram3,y
	BNE +
	LDA $0300,x
	STA !Xpos2,y
+	LDA !Ypos2,y
	CLC
	ADC $05
	STA $0301,x
	LDA !Ram3,y
	BNE +
	LDA $0301,x
	STA !Ypos2,y
	LDA !Ram5,y
	ORA $00
	LSR A
	AND #$01
	STA $02
	LDA !Tile2,y
	AND #$FE
	ORA $02
	STA !Tile2,y
	LDA #$50
	STA !Ram4,y
+	LDA !Ram5,y
	ORA $00
	AND #$03
	TAY
	LDA .Tile,y
	STA $0302,x
	LDA .Color,y
	STA $0303,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0460,y
	LDX $15E9
	RTS
.Num	db $01,$01,$00,$01,$02,$03,$03,$03
	db $02,$01,$02,$01,$00,$01,$00,$00
.Num2	db $00,$01,$03,$03
.Num3	db $01,$02,$03,$04

.XPos	db $50,$50,$50,$50,$50,$50,$50,$48,$48,$48,$48,$40,$40,$40,$40,$40
.XPos2	db $A0,$A0,$A0,$A0,$A0,$A0,$A0,$A8,$A8,$A8,$A8,$B0,$B0,$B0,$B0,$B0
.YPos	db $4F,$4F,$4F,$4F,$4F,$47,$47,$47,$47,$3F,$3F,$3F,$3F,$3F,$37,$37
.YPos2	db $8F,$8F,$8F,$8F,$8F,$97,$97,$97,$97,$9F,$9F,$9F,$9F,$9F,$A7,$A7

.X	db $04,$04,$04,$04,$04,$04,$04,$05,$05,$05,$05,$06,$06,$06,$06,$06
.Y	db $03,$03,$03,$03,$03,$04,$04,$04,$04,$05,$05,$05,$05,$05,$06,$06
.Ptr	dw .X,.Y,.X,.Y

.x	db $F0,$F0,$00,$00,$10,$10,$00,$00
.y	db $00,$00,$F0,$F0,$00,$00,$10,$10
.XSpd	db $FF,$FE,$00,$00,$01,$02,$00,$00
.YSpd	db $00,$00,$FF,$FE,$00,$00,$01,$02

.Spd	db $01,$02
.Tile	db $E4,$E6,$24,$24
.Color	db $00,$00,$0A,$0A
.Tile2	db $00,$02,$04,$06,$08,$0A,$0C,$0E,$20,$22,$24,$26,$28,$2A,$2C,$2E
.Tile3	;db $80
	db $82,$84,$86,$88,$8A,$8C,$8E,$A0,$A2,$A4,$A6,$A8,$AA,$AC,$AE,$C0
.Tile4	db $C0,$42,$44,$46,$48,$4A,$4C,$4E,$60,$62,$64,$40,$68,$6A,$6C,$6E
.Tile5	db $C0,$C2,$C4,$C6,$C8,$CA,$CC,$CE,$E0,$E2,$E4,$E6,$E8,$EA,$EC,$EE

.Tile6	db $2E,$2C,$2A,$28,$26,$24,$22,$20,$0E,$0C,$0A,$08,$06,$04,$02,$00
.Tile7	db $C0,$AE,$AC,$AA,$A8,$A6,$A4,$A2,$A0,$8E,$8C,$8A,$88,$86,$84,$82;,$80
.Tile8	;db $6E,
	db $6C,$6A,$68,$40,$64,$62,$60,$4E,$4C,$4A,$48,$46,$44,$42,$C0,$C0
.Tile9	db $EE,$EC,$EA,$E8,$E6,$E4,$E2,$E0,$CE,$CC,$CA,$C8,$C6,$C4,$C2,$C0
.TilePtr	dw .Tile4,.Tile7,.Tile6,.Tile5
.TilePtr2	dw .Tile2,.Tile9,.Tile8,.Tile3
;==========================================
Swap:	LDA !Ram2,x
	BEQ +
	RTS
+	LDA !Tile2,x
	AND #$01
	ASL A
	STA $06
	LDA !Tile2,x
	AND #$FE
	TAY
	REP #$20
	LDA Move_Ptr,y
	STA $00
	SEP #$20
	LDY $0E
	LDA ($00),y
	DEC A
	STA $00
	STA $03
	LDA Square,y
	INC A
	STA $02
	LDA Move_X,y
	STA $01
	LDA !Tile2,x
	AND #$FE
	TAY
	LDA $0B
	CLC
	ADC Move_x,y
	INC #2
	AND #$F8
	STA $04
	LDA Move_y,y
	BEQ +
	CMP #$10
	BEQ +
	LDA $01
	EOR #$FF
	INC A
	STA $01
+	LDA $0C
	CLC
	ADC Move_y,y
	DEC #2
	ORA #$07
	STA $05
	LDA Move_x,y
	BEQ +
	LDA .Count,y
	STA $01
+	LDY #$00
-	LDA !Xpos,y
	CMP $04
	BNE +
	LDA !Ypos,y
	CMP $05
	BNE +
	LDA $06
	PHA
--	LDA !Tile,y
	PHA
	TYA
	SEC
	SBC $01
	TAY
	DEC $00
	BPL --
	PLA
	STA !Ram5,x
	BEQ ++
	INC !Ram6
++ : --	TYA
	CLC
	ADC $01
	TAY
	PLA
	STA !Tile,y
	DEC $03
	BPL --
	INC !Ram2,x
	LDA #$10
	STA !Ram3,x
	RTS
+	INY
	DEC $02
	BPL -
	RTS
.Count	db $FF,$FF,$00,$00,$01,$01,$00,$00
;==========================================
Check:	LDA $151C,x
	LSR A
	TAY
	INC #2
	STA $1602,x
	CMP $1594,x
	BEQ .Clear
	LDA $E4,x
	CLC
	ADC #$04
	SEC
	SBC SubGfx_Xoffset,y
	AND #$F0
	ORA SubGfx_Xoffset,y
	STA $00
	LDA Square,y
	INC A
	STA $02
	LDA $D8,x
	CLC
	ADC #$10
	CLC
	ADC SubGfx_Yoffset,y
	AND #$F0
	SEC
	SBC SubGfx_Yoffset,y
	STA $01
	LDY #$00
-	LDA !Xpos,y
	CMP $00
	BNE +
	LDA !Ypos,y
	CMP $01
	BNE +
	LDA #$80
	STA !Ram7
	LDA $16
	ORA $18
	BPL +++
	LDA !Mask,y
	BMI +++
	LDA !Tile,y
	BEQ ++
	LDA #$80
	STA !Mask,y
	INC $1594,x
	LDA #$0D
	JSR Get1Up
	LDA !Tile,y
++	LSR A
	TAY
	BNE ++
	INC $C2,x
	LDA #$05
	JSR Get1Up
++	LDA .Sound,y
	STA $1DFC
+++	RTS
.Clear	INC $C2,x
	LDA $94
	STA $E4,x
	LDA $96
	CLC
	ADC #$48
	STA $D8,x
	LDA #$0F
	JMP Get1Up
+	INY
	DEC $02
	BPL -
	STZ !Ram7
	RTS
.Sound	db $2A,$29
;==========================================
Fin:	LDA $14AB
	BNE End
	LDA #$44
	STA $14AB
End:	RTS
;==========================================
Get1Up:	PHY
	XBA
	LDY #$05
-	LDA $16E1,y
	BEQ +
	DEY
	BPL -
	DEC $18F7
	BPL ++
	LDA #$05
	STA $18F7
++	LDY $18F7
+	XBA
	STA $16E1,y
	LDA $D8,x
	SEC
	SBC #$38
	STA $16E7,y
	XBA
	LDA #$01
	SBC #$00
	STA $16F9,y
	XBA
	SEC
	SBC $1C
	CMP #$F0
	BCC +
	LDA $16E7,y
	ADC #$10
	STA $16E7,y
	LDA $16F9,y
	ADC #$00
	STA $16F9,y
+	LDA $E4,x
	STA $16ED,y
	LDA #$00
	STA $16F3,y
	LDA #$30
	STA $16FF,y
	PLY
	RTS
;==========================================
SubGfx:	LDA $151C,x
	ASL A
	TAY
	LSR #2
	STA $06
	LSR A
	STA $05
	REP #$20
	LDA ScoreTile_Ptr,y
	STA $03
	SEP #$20
	LDY $06
	LDA .Xoffset,y
	STA $0E
	LDA .Yoffset,y
	STA $0F
	STZ $01
	LDA !Ram7
	BPL +
	LDA #$30
	STA $01
+	LDA $14
	AND #$1F
	TAY
	LDA .Tile,y
	STA $00
	LDA #$18
	STA $0200
	LDA #$28
	STA $0204
	LDA #$20
	STA $0201
	STA $0205
	LDA #$80
	STA $0202
	LDA #$82
	STA $0206
	LDA #$26
	STA $0203
	STA $0207
	LDA #$02
	STA $0420
	STA $0421
	LDA $C2,x
	CMP #$05
	BEQ ++
	JMP +
++	LDY #$10
	LDA $E4,x
	STA $0200,y
	STA $0204,y
	STA $0208,y
	STA $020C,y
	CLC
	ADC #$04
	SEC
	SBC $0E
	AND #$F0
	ORA $0E
	STA $0210,y
	STA $0214,y
	LDA $D8,x
	CLC
	ADC #$10
	STA $0201,y
	STA $0205,y
	CLC
	ADC #$08
	STA $0209,y
	STA $020D,y
	CLC
	ADC #$F7
	ADC $0F
	AND #$F0
	SEC
	SBC $0F
	STA $0211,y
	STA $0215,y
	LDA #$AE
	CLC
	ADC $01
	STA $0202,y
	STA $0206,y
	ADC #$10
	STA $020A,y
	STA $020E,y
	LDA $00
	STA $0212,y
	STA $0216,y
	LDA #$24
	STA $0203,y
	STA $0207,y
	STA $020B,y
	STA $020F,y
	STA $0213,y
	STA $0217,y
	TYA
	LSR #2
	TAX
	LDA #$02
	STA $0420,x
	STA $0422,x
	STA $0424,x
	INC A
	STA $0421,x
	STA $0423,x
	STA $0425,x
	LDA #$04
	STA $02
	LDA #$59
	STA $0E
	LDA #$C4
	STA $0F
	LDY #$20
-	LDA #$F0
	CMP $0301,y
	BNE ++
	LDA $0E
	STA $0300,y
	CLC
	ADC #$10
	STA $0E
	LDA #$28
	STA $0301,y
	LDA $0F
	STA $0302,y
	INC #2
	STA $0F
	LDA #$26
	STA $0303,y
	TYA
	LSR #2
	TAX
	LDA #$02
	STA $0460,x
	DEC $02
++	INY #4
	LDA $02
	BPL -
+	LDA #$01
	STA $02
	LDX #$08
-	LDA #$F0
	CMP $0201,x
	BNE +
	LDY $02
	LDA .XDisp,y
	STA $0200,x
	LDA #$20
	STA $0201,x
	LDA ($03),y
	STA $0202,x
	LDY $05
	LDA .Color,y
	STA $0203,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0420,y
	DEC $02
+	INX #4
	LDA $02
	BPL -
	LDY $15E9
	LDA $00C2,y
	CMP #$02
	BCS +
	TYX
	RTS
+	LDY $06
	LDA Square,y
	STA $02
	LDY $15E9
	LDA $00C2,y
	CMP #$06
	BEQ ++
	CMP #$03
	BCS +
++	LDA $14
	AND #$08
	LSR #3
	BRA ++
+	LDA #$04
++	STA $03
-	LDA #$F0
	CMP $0301,x
	BNE +
	LDY $02
	LDA !Xpos,y
	STA $0300,x
	LDA !Ypos,y
	STA $0301,x
	LDA !Mask,y
	BPL ++
	LDA #$00
	BRA +++
++	LDA $03
+++	ORA !Tile,y
	TAY
	LDA Mouse_Tile,y
	STA $0302,x
	LDA Mouse_Color,y
	STA $0303,x
	TXA
	LSR #2
	TAY
	LDA #$02
	STA $0460,y
	DEC $02
+	INX #4
	LDA $02
	BPL -
	LDX $15E9
	RTS
.Tile	db $A8,$A8,$A8,$A8,$A8,$A8,$A8,$A8
	db $A8,$A8,$A8,$A8,$A8,$AA,$AA,$AA
	db $AC,$AC,$AC,$AC,$AC,$AC,$AC,$AC
	db $AC,$AC,$AC,$AC,$AC,$AA,$AA,$AA
.XDisp	db $38,$40
.Color	db $26,$2A,$24,$28,$2C,$22,$20,$2E
.Xoffset	db $00,$00,$00,$00,$00,$00,$00,$08,$08,$08,$08,$00,$00,$00,$00,$00
.Yoffset	db $01,$01,$01,$01,$01,$09,$09,$09,$09,$01,$01,$01,$01,$01,$09,$09
ScoreTile:
.1	db $84,$86
.2	db $84,$88
.3	db $84,$8A
.4	db $84,$8C
.5	db $84,$8E
.6	db $84,$A0
.7	db $84,$A2
.8	db $84,$A4
.9	db $84,$A6
.10	db $86,$84
.11	db $86,$86
.12	db $86,$88
.13	db $86,$8A
.14	db $86,$8C
.15	db $86,$8E
.16	db $86,$A0
.17	db $86,$A2
.18	db $86,$A4
.19	db $86,$A6
.20	db $88,$84
.21	db $88,$86
.22	db $88,$88
.23	db $88,$8A
.24	db $88,$8C
.25	db $88,$8E
.26	db $88,$A0
.27	db $88,$A2
.28	db $88,$A4
.29	db $88,$A6
.30	db $8A,$84
.Ptr	dw .1,.2,.3,.4,.5,.6,.7,.8,.9,.10
	dw .11,.12,.13,.14,.15,.16,.17,.18,.19,.20
	dw .21,.22,.23,.24,.25,.26,.27,.28,.29,.30
Square:	db $0B,$0B,$0B,$0B,$0B,$0F,$0F,$13
	db $13,$18,$18,$1D,$1D,$1D,$23,$23
Mouse:	db $01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10
.Tile	db $E4,$E6,$24,$24,$E2,$E2,$E2,$E2
.Color	db $20,$20,$2A,$2A,$20,$20,$20,$20
;.Unko	dd $68747541,$553A726F,$2059386E
;