!XSpeed	= $0F4A
!YSpeed	= $0F4B
!XPos = $0F4C
!YPos = $0F4E
!Solid	= $0F50
!Direction = $0F51
!JumpTimer = $0F52
!FallTimer = $0F53
!XPosPrev = $0F54
!YPosPrev = $0F56
!XFract	= $0F58
!YFract = $0F5A
!XSpeedMod = $0F5C
!YSpeedMod = $0F5D
!JumpFlag = $0F5E
!HitHeadFlag = $0F5F

!pointA_X = $0F60
!pointA_Y = $0F62
!pointB_X = $0F64
!pointB_Y = $0F66
!pointcheck = $0F60
!pointC_X = $0F68
!pointC_Y = $0F6A
!pointD_X = $0F6C
!pointD_Y = $0F6E
!pointH_X = $0F70
!pointH_Y = $0F72
!pointP_X = $0F74
!pointP_Y = $0F76
!bird_x = $0F78

!CoinGrab = $0F79
!SpinJump = $0F7A
!DisableFlag = $0F7B
!NoBonk = $0F7C
!InvisiBlockContact = $0F7D
!rotspeed = $0F7E
!rotfloat = $0F7F

!BlockUpdate = $0F80
!BlockVRAMAddr = $0F81
!BlockIndex = $0F83

!collecttable = $0FAF
!itembox = $0FBB
!endlevel = $0FBC
!powerup = $0FBD

!Map16 = $7EAD00


	LDA $13D4
	BEQ +
	RTS
+
	JSR Input
	JSR PlayerHandler
	JSR Rotation
	LDA !endlevel
	BEQ +
	JSR endlevelroutine
	BRA .superskip
+
	JSR SpeedHandler
	JSR PositionHandler
	JSR InteractionHandler
	BRA ++
.superskip
	LDA $14AB
	CMP #$45
	BCC +
++
	JSR CoinSparkle
	JSR DrawBackground
+
	RTS

incsrc player.asm
incsrc circle.asm
incsrc position.asm
incsrc background.asm
incsrc interaction.asm
incsrc input.asm
incsrc rotation.asm


BlockVRAMConvert:
	INC !BlockUpdate
	INC !BlockUpdate
	INC !BlockUpdate
	LDX !BlockUpdate
	STA !BlockIndex,x
	REP #$20
	LDA $0D
	ASL #2
	AND #$FF00
	STA $00
	LDA $0D
	ASL
	AND #$007F
	CLC : ADC $00
	STA !BlockVRAMAddr,x
	SEP #$20
	RTS


endlevelroutine:
	DEC
	BEQ .muncher

.moon
	LDA !rotspeed
	CLC : ADC #$03
	BCS +
	STA !rotspeed
	BRA +

.muncher
	STZ !rotspeed
+
	LDA $14
	AND #$03
	BNE +
	REP #$21
	LDA $0703
	ADC.w #%0000010000100001	;fade color 0 to white
	BVS ++
	STA $0703
++
	SEP #$20
+
	LDA $14AB
	CMP #$44
	BCS +
	LDA !powerup : STA $19
	LDA !itembox : STA $0DC2
	LDA #$01 : STA $3E
	STZ $0D9E
	LDA #$10 : STA $0D9D
	LDA #$26 : STA $13E0	;victory pose
	STZ $76
	LDA !endlevel
	DEC : BEQ +
	LDA #$78 : STA $0300	;draw 3UP sprite
	LDA #$50 : STA $0301
	LDA #$28 : STA $0302
	LDA #$36 : STA $0303
	STZ $0460
+
	RTS



CoinSparkle:
	LDY #$09
-
	LDA !collecttable,y
	BEQ +
	DEC
	STA !collecttable,y
	BEQ ++
	CMP #$06
	BNE +
	REP #$20
	LDA !collecttable+1,y
	STA $0D
	SEP #$20
	LDA #$14
	JSR BlockVRAMConvert
+
--
	DEY #3 : BPL -
	RTS
++
	REP #$20
	LDA !collecttable+1,y
	STA $0D
	SEP #$20
	LDA #$00
	JSR BlockVRAMConvert
	BRA --