PlayerHandler:
	LDA !InvisiBlockContact
	BEQ +
	REP #$20
	LDA !XPos
	CMP.w #$00F0-$0080
	BCC ++
	SEP #$20
	STZ !InvisiBlockContact
	BRA +
++
	CMP.w #$00D0-$0080
	BCS +
	SEP #$20
	STZ !InvisiBlockContact
	REP #$10
	LDA #$01
	STA !Map16+$05CE
	STA !Map16+$060E
	STA !Map16+$064E
	LDX #$05CE : STX $0D
	SEP #$10
	LDA #$18
	JSR BlockVRAMConvert
	REP #$10
	LDX #$060E : STX $0D
	SEP #$10
	LDA #$18
	JSR BlockVRAMConvert
	REP #$10
	LDX #$064E : STX $0D
	SEP #$10
	LDA #$18
	JSR BlockVRAMConvert
+
	SEP #$20

	STZ $7B : STZ $7D
	LDA !Solid
	AND #$04
	BNE +
	LDA !SpinJump
	BNE ++
	LDA !YSpeed
	ASL
	LDA #$00
	ADC #$00
	TAX
	LDA .jump,x
	STA $13E0
	RTS

++
	LDA $13
	LSR #2
	AND #$01 : STA $76
	LDA $13
	LSR : AND #$03
	TAX
	LDA .spinjump,x
	STA $13E0
	RTS

+
	LDA !XSpeed
	BPL +
	EOR #$FF : INC
+
	BEQ +
	LDA $13
	AND #$08
	LSR #3
	TAX
	LDA .walk,x
+
	STA $13E0
	RTS

.jump
db $24,$0B

.spinjump
db $00,$25,$00,$0F

.walk
db $00,$01


-
LDA !XSpeed
BRA +

SpeedHandler:
	LDA !Solid
	AND #$03
	BEQ +++
	LDA !DisableFlag
	BNE -
	LDA #$00
	BRA +
+++
	LDA !XSpeed
	BEQ +
	BMI ++
	DEC : DEC
++
	INC
+
	STA !XSpeed

.yspeedcheck
	LDA !Solid
	BIT #$04
	BEQ .not_on_ground
.on_ground
	LDA #$30
	STA !FallTimer
	LDA #$10
	STA !YSpeed
	STZ !JumpFlag
	STZ !HitHeadFlag
	STZ !SpinJump
	BRA .skip

.not_on_ground
	BIT #$08
	BEQ .not_hitting_ceiling
.hitting_ceiling
	LDA !HitHeadFlag
	BNE .falling
	LDA #$08
	TRB !Solid
	STZ !JumpTimer
	LDA #$2F
	STA !FallTimer
	LDA #$10
	STA !YSpeed
	LDA !NoBonk
	BNE +
	LDA #$01
	STA $1DF9
+
	STZ !NoBonk
	LDA #$01
	STA !HitHeadFlag
	BRA .falling

.not_hitting_ceiling
	LDA !JumpTimer
	BEQ .falling
.jumping
	LSR #2 : TAX
	LDA .jumpspeed,x
	STA !YSpeed
	DEC !JumpTimer
	BRA .skip

.falling
	LDA !JumpFlag
	BNE +
	LDA #$01
	STA !HitHeadFlag
	STZ !YSpeed
	INC !JumpFlag
+
	DEC !FallTimer
	BEQ .skip
	INC !YSpeed

.skip
	RTS

.jumpspeed
	db $00,$F8,$E4,$D8,$D0,$D0,$D0,$D0
.fallspeed
	db $03,$02,$01,$00