PositionHandler:

;Horizontal
	REP #$20
	LDA $36 : EOR #$01FF : STA $04
	SEP #$20
	LDA !XSpeed : BPL +
	INC $05
	LDA !XSpeed
	EOR #$FF : INC
	+
	STA $06
	JSR circleX
	JSR circleY
	LDA $07 : STA !XSpeedMod
	LDA $08 : STA !YSpeedMod

;Vertical
	REP #$21
	LDA $36 : EOR #$01FF : ADC #$0080 : STA $04
	SEP #$20
	LDA !YSpeed : BPL +
	INC $05
	LDA !YSpeed
	EOR #$FF : INC
	+
	STA $06
	JSR circleX
	JSR circleY

;Speed Modifier
	STZ !XFract+1
	STZ !YFract+1

.handleX
	LDA $07
	CLC : ADC !XSpeedMod
	BMI .negativeX
	REP #$20
	AND #$00FF
	ASL #4
	ADC !XFract
	SEP #$20
	STA !XFract
	XBA
	REP #$21
	AND #$000F
	ADC !XPos
	STA !XPos
	SEP #$20
	BRA .handleY

.negativeX
	EOR #$FF : INC
	REP #$20
	AND #$00FF
	ASL #4
	ADC !XFract
	SEP #$20
	STA !XFract
	XBA
	EOR #$FF : INC
	REP #$21
	AND #$00FF
	BEQ +
	ORA #$FF00
	+
	ADC !XPos
	STA !XPos
	SEP #$20

.handleY
	LDA $08
	CLC : ADC !YSpeedMod
	BMI .negativeY
	REP #$20
	AND #$00FF
	ASL #4
	ADC !YFract
	SEP #$20
	STA !YFract
	XBA
	REP #$21
	AND #$000F
	ADC !YPos
	STA !YPos
	BRA .finishup

.negativeY
	EOR #$FF : INC
	REP #$20
	AND #$00FF
	ASL #4
	ADC !YFract
	SEP #$20
	STA !YFract
	XBA
	EOR #$FF : INC
	REP #$21
	AND #$00FF
	BEQ +
	ORA #$FF00
	+
	ADC !YPos
	STA !YPos

.finishup	;Store to mirrors
	LDA !XPos : STA $2A : STA $3A
	LDA !YPos : STA $2C : STA $3C
	SEP #$20
	RTS