levelinit106:		
	ldx.b #boot_end-boot_evil
	-
		lda.l boot_evil,x
		sta $7F8182,x
		dex
		bpl -
	rts
	
upload_shit:
        rep #$10
	ldx #evil_end-start
	-
		lda.l start,x
		sta $00683,x
		dex
		cpx #$FFFF
		bne -
		sep #$10
		jsl $000683
		rtl
        
       
	boot_evil:
	base $7F8182 
		lda $94
		sta $0DBF
		ldx $18 
		;beq + 
			rep #$10
			ldx $F0 
			sta $0680,x
			inx
			stx $F0
			cpx #$0153
			php
			jsl upload_shit
			plp
			sep #$10
			bcc + 
				jsl $000683
		+
		rtl
	base off
	boot_end:
	
start:
macro generate_new_pipe()	
	lsr #3
	bit #$0020
	bne +
		adc #$03E0
	+
	adc #$2000-32+3
	sta $10
	
	ldx #$23
	stx $00		;DMA source, can't change
	
	ldy #$03
	-
		lda $10
		sta $2116
		
		ldx #$20
		stx $22		;enable collision detection for 32 frames
		stx $4315
		
		ldx #$01
		stx $2115
		inx
		stx $420B
		
		ldx #$81
		stx $2115

		dec $00
		dec $10
		
		lda $148D
		and #$01E0
		adc #$0060+1
		pha
		adc $10
		
		sta $2116
		
		cmp #$2424
		pla
		bcs +
			adc #$0040
		+
		sta $24
		
		ldx #$09
		.next_piece
			tya
			cpx #$08
			bcs .pipe
				cpx #$02
				bcc .pipe
				tdc
		.pipe
			clc
			adc pipe_tiles,x
			and #$00FF
			cpx #$02
			bcs .not_bottom
				ora #$8000
			.not_bottom
			sta $2118
			dex
			bpl .next_piece
		
		
		dey
		bpl -
		
endmacro

macro run_frame()
	;draw the player
	jsr $A300
	jsr $8449
	
	;screen updates
	jsr $8420
	
	;animate
	inc $13
	lda $13
	lsr
	and #$02
	adc #$18
	sta $13E0
	
	;pipe generation code
	rep #$21
	inc $1A
	lda $1A
	and #$01FF
	bit #$007F
	bne .skip_pipe
		pei ($24)
		%generate_new_pipe()
	.skip_pipe
	
	;run collision detection
	ldx $22
	beq .no_collision_check
		lda $01,s
		beq .no_collide
		lsr
		lsr
		sbc $96
		adc #$0020-8
		cmp #$0030-8
		bcc .not_dead
		.dead
			pla
			sep #$30
			
			lda $20
			lsr #2
			tay
			
			.next_life
				ldx #$10
				lda #$05
				sta $2143
				inc $0DBE
				.wait_sound
					jsr do_wait
					jsr do_wait
					stz $2143
					dex
					bne .wait_sound
				dey
				sty $5000
				bpl .next_life
			lda #$80
			sta $2142
			ldx #$0F
			.darken
				stx $2100
				ldy #$04
				.darken_wait
					jsr do_wait
					dey
				bpl .darken_wait
				dex
			bpl .darken
			lda #$0C
			sta $0100
			lda #$00
			stz $0DAE 
			stz $0DAF
			cld
			jml $008070
		.not_dead
	.no_collide
		dec $22
		bne +
			inc $20
			pla
		+
	.no_collision_check
	
	;status bar address
	lda #$5000
	sta $2116
	
	;fix palettes part 1
	;lda #$01FE
	;sta $0905

	;run physics
	ldx $7D
	lda $4218
	sep #$30
	beq +
		ldx #$E0
	+
	inx
	inx
	stx $7D
	
	jsr $DC2D
		
	;run fix palette part 2
	;ldy #$03
	;jsr $A48B
	
	;status bar
	lda $20
	jsr $9045
	stz $2115
	stx $2118
	sta $2118
	
	;draw mario
	jsl $00E2BD

	;update rng
	jsl $01ACF9

endmacro
base $000683
reset bytes
reset:
	;databank fix
	phd
	plb
	
	sep #$30
	
	;delete our bootloader
	lda #$6B
	sta $7F8182
	
	jsr clear_vram
	jsr $860C

	-
		stz $00,x
		dex 
	bne -
	
	sty $76
	
	dec $4311
	
	;enable the screen
	lda #$0F
	sta $2100
	
	;gameloop
	.next_frame 
		lda $4212
		bpl .next_frame
		%run_frame()
	.wait_frame
		jsr $9263
		jmp .next_frame
		
clear_vram:
	;clear status bar
	jsr $85FA
	
	;enable autojoy and clear layer 1
	sty $4200
	iny
	jsr config_vram_clear
	jsr $862D
	
	lda #$F8
	jsr config_vram_clear
	stz $2115
	rts
	
config_vram_clear:
	sta $00
	stz $2116
	lda #$20
	sta $2117
	rts
	
do_wait:
	.next_frame
		lda $4212
	bpl .next_frame
	.wait_nmi_end
		lda $4212
	bmi .wait_nmi_end
	
complement:
	db $EF

pipe_tiles:
	db $00, $10, $F8, $F8, $F8, $F8, $F8, $F8, $10, $00
print pc
base off
evil_end:
